package compiler;

import org.apache.commons.cli.Option;
import org.apache.commons.cli.Options;

public class ConsumerTemplates {
	
	public static String getMQTT(String className, String schemaName) {
		String mqtt = "import java.util.ArrayList;\r\n"
				+ "import java.util.Timer;\r\n"
				+ "import java.util.TimerTask;\r\n"
				+ "import java.util.concurrent.LinkedBlockingQueue;\r\n"
				+ "import org.apache.commons.cli.*;\r\n"
				+ "import org.eclipse.paho.client.mqttv3.IMqttDeliveryToken;\r\n"
				+ "import org.eclipse.paho.client.mqttv3.MqttCallback;\r\n"
				+ "import org.eclipse.paho.client.mqttv3.MqttClient;\r\n"
				+ "import org.eclipse.paho.client.mqttv3.MqttConnectOptions;\r\n"
				+ "import org.eclipse.paho.client.mqttv3.MqttMessage;\r\n"
				+ "import com.fasterxml.jackson.core.JsonProcessingException;\r\n"
				+ "import com.fasterxml.jackson.core.type.TypeReference;\r\n"
				+ "import com.fasterxml.jackson.databind.DeserializationFeature;\r\n"
				+ "import com.fasterxml.jackson.databind.ObjectMapper;\r\n"
				+ "import com.fasterxml.jackson.databind.SerializationFeature;\r\n"
				+ "\r\n"
				+ " public class "+className+" implements MqttCallback {\r\n"
				+ "	private Timer timerWaitTime;\r\n"
				+ "	private long milisec;\r\n"
				+ "\r\n"
				+ "	private Timer timerTimeRep;\r\n"
				+ "	private long milisecRep;\r\n"
				+ "\r\n"
				+ "	private int numMessages;\r\n"
				+ "	private int numMessagescont;\r\n"
				+ "\r\n"
				+ "	private int maxMessages;\r\n"
				+ "	private int maxMessagescont;\r\n"
				+ "\r\n"
				+ "	private boolean delused;\r\n"
				+ "	private boolean finalexec;\r\n"
				+ "\r\n"
				+ "	private String clientId;\r\n"
				+ "\r\n"
				+ "	private Timer timerEnd;\r\n"
				+ "	private boolean end;\r\n"
				+ "\r\n"
				+ "	private boolean persistent;\r\n"
				+ "	private Timer timerPersistent;\r\n"
				+ "\r\n"
				+ "	private LinkedBlockingQueue<"+schemaName+"> lbq;\r\n"
				+ "\r\n"
				+ "	MqttClient client;\r\n"
				+ "\r\n"
				+ "	private String username;\r\n"
				+ "	private String password;\r\n"
				+ "	private String brokerUrl;\r\n"
				+ "	private String topic;\r\n"
				+ "\r\n"
				+ " private Thread t;\r\n"
				+ "\r\n"
				+ "	public static void main(String[] args) {\r\n"
				+ "		"+className+" consumer = new "+className+"(args);\r\n"
				+ "	}\r\n"
				+ "\r\n"
				+ "	public "+className+"(String[] argv) {\r\n"
				+ "		configParam(argv);\r\n"
				+ "		lbq = new LinkedBlockingQueue<"+schemaName+">();\r\n"
				+ "		clientId = MqttClient.generateClientId();\r\n"
				+ "\r\n"
				+ "		try {\r\n"
				+ "			if(persistent) {\r\n"
				+ "				doWork();\r\n"
				+ "				timerPersistent = new Timer();\r\n"
				+ "				TimerTask task_pers = new TimerTask() {\r\n"
				+ "					@Override\r\n"
				+ "					public void run() {\r\n"
				+ "						try {\r\n"
				+ "							if(!t.isAlive()) {\r\n"
				+ "								end();\r\n"
				+ "							}\r\n"
				+ "						} catch (Exception e) {\r\n"
				+ "							e.printStackTrace();\r\n"
				+ "						}\r\n"
				+ "					}\r\n"
				+ "				};\r\n"
				+ "				timerPersistent.scheduleAtFixedRate(task_pers, 10, 10);\r\n"
				+ "			}\r\n"
				+ "			client = new MqttClient(brokerUrl, clientId, null);\r\n"
				+ "			MqttConnectOptions connOpts = new MqttConnectOptions();\r\n"
				+ "			connOpts.setCleanSession(true);\r\n"
				+ "			connOpts.setAutomaticReconnect(true);\r\n"
				+ "			connOpts.setConnectionTimeout(0);\r\n"
				+ "			if (!username.equals(\"\")) connOpts.setUserName(username);\r\n"
				+ "			if (!password.equals(\"\")) connOpts.setPassword(password.toCharArray());\r\n"
				+ "			client.connect(connOpts);\r\n"
				+ "			client.setCallback(this);\r\n"
				+ "			client.subscribe(topic);\r\n"
				+ "\r\n"
				+ "			if (milisec > 0) {\r\n"
				+ "				timerWaitTime = new Timer();\r\n"
				+ "				TimerTask task = new TimerTask() {\r\n"
				+ "					@Override\r\n"
				+ "					public void run() {\r\n"
				+ "						try {\r\n"
				+ "							end();\r\n"
				+ "						} catch (Exception e) {\r\n"
				+ "							e.printStackTrace();\r\n"
				+ "						}\r\n"
				+ "					}\r\n"
				+ "				};\r\n"
				+ "				timerWaitTime.schedule(task, milisec);\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (milisecRep > 0) {\r\n"
				+ "				timerTimeRep = new Timer();\r\n"
				+ "				TimerTask task_rep = new TimerTask() {\r\n"
				+ "					@Override\r\n"
				+ "					public void run() {\r\n"
				+ "						try {\r\n"
				+ "							doWork();\r\n"
				+ "						} catch (Exception e) {\r\n"
				+ "							e.printStackTrace();\r\n"
				+ "						}\r\n"
				+ "					}\r\n"
				+ "				};\r\n"
				+ "				timerTimeRep.scheduleAtFixedRate(task_rep, milisecRep, milisecRep);\r\n"
				+ "			}\r\n"
				+ "		} catch (Exception e) {\r\n"
				+ "			e.printStackTrace();\r\n"
				+ "			System.exit(0);\r\n"
				+ "		}\r\n"
				+ "	}\r\n"
				+ "\r\n"
				+ "	public void connectionLost(Throwable arg0) {\r\n"
				+ "	}\r\n"
				+ "\r\n"
				+ "	@Override\r\n"
				+ "	public void deliveryComplete(IMqttDeliveryToken arg0) {\r\n"
				+ "	}\r\n"
				+ "\r\n"
				+ "	public void messageArrived(String topic, MqttMessage message) {\r\n"
				+ "		if (timerWaitTime != null)\r\n"
				+ "			reset();\r\n"
				+ "		try {\r\n"
				+ "			processMessage(new String(message.getPayload(), \"UTF-8\"));\r\n"
				+ "			if (maxMessages != 0) {\r\n"
				+ "				maxMessagescont++;\r\n"
				+ "				if (maxMessagescont != 0 && maxMessages == maxMessagescont) {\r\n"
				+ "					timerEnd = new Timer();\r\n"
				+ "					TimerTask task_end = new TimerTask() {\r\n"
				+ "						@Override\r\n"
				+ "						public void run() {\r\n"
				+ "							try {\r\n"
				+ "								end();\r\n"
				+ "							} catch (Exception e) {\r\n"
				+ "								e.printStackTrace();\r\n"
				+ "							}\r\n"
				+ "						}\r\n"
				+ "					};\r\n"
				+ "					timerEnd.schedule(task_end, 0);\r\n"
				+ "				}\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (numMessages != 0) {\r\n"
				+ "				numMessagescont++;\r\n"
				+ "				if (numMessages != 0 && numMessages == numMessagescont) {\r\n"
				+ "					doWork();\r\n"
				+ "					numMessagescont = 0;\r\n"
				+ "				}\r\n"
				+ "			}\r\n"
				+ "		} catch (Exception e) {\r\n"
				+ "			e.printStackTrace();\r\n"
				+ "		}\r\n"
				+ "	}\r\n"
				+ "\r\n"
				+ "	private void processMessage(String message) {\r\n"
				+ "		ObjectMapper mapper = new ObjectMapper().\r\n"
				+ "				enable(SerializationFeature.INDENT_OUTPUT).\r\n"
				+ "				enable(DeserializationFeature.ACCEPT_SINGLE_VALUE_AS_ARRAY);\r\n"
				+ "		try {\r\n"
				+ "			ArrayList<"+schemaName+"> dataToProcess = mapper.readValue(message, new TypeReference<ArrayList<"+schemaName+">>() {\r\n"
				+ "			});\r\n"
				+ "			lbq.addAll(dataToProcess);\r\n"
				+ "		} catch (JsonProcessingException e) {\r\n"
				+ "			System.out.println(\"Warning: Malformed message\");\r\n"
				+ "			System.out.println(message);\r\n"
				+ "		}\r\n"
				+ "	}\r\n"
				+ "\r\n"
				+ "	private void doWork() {\r\n"
				+ "		\r\n"
				+ "		if(t == null) {\r\n"
				+ "			if(!persistent) {\r\n"
				+ "				LinkedBlockingQueue<"+schemaName+"> clone = new LinkedBlockingQueue<>();\r\n"
				+ "				clone.addAll(lbq);\r\n"
				+ "				Runnable algorithm = new Algorithm(clone);\r\n"
				+ "				t = new Thread(algorithm);\r\n"
				+ "				t.start();\r\n"
				+ "			} else {\r\n"
				+ "				Runnable algorithm = new Algorithm(lbq);\r\n"
				+ "				t = new Thread(algorithm);\r\n"
				+ "				t.start();\r\n"
				+ "			}\r\n"
				+ "		} else if (!persistent) {\r\n"
				+ "			if(!t.isAlive()) {\r\n"
				+ "				LinkedBlockingQueue<"+schemaName+"> clone = new LinkedBlockingQueue<>();\r\n"
				+ "				clone.addAll(lbq);\r\n"
				+ "				Runnable algorithm = new Algorithm(clone);\r\n"
				+ "				t = new Thread(algorithm);\r\n"
				+ "				t.start();\r\n"
				+ "			}\r\n"
				+ "		}\r\n"
				+ "		\r\n"
				+ "		if (delused) {\r\n"
				+ "			lbq.clear();\r\n"
				+ "		}\r\n"
				+ "		\r\n"
				+ "		if (end) {\r\n"
				+ "			try {\r\n"
				+ "				t.join();\r\n"
				+ "			} catch (InterruptedException e) {\r\n"
				+ "				e.printStackTrace();\r\n"
				+ "			}\r\n"
				+ "		}\r\n"
				+ "	}\r\n"
				+ "\r\n"
				+ "	private void reset() {\r\n"
				+ "		timerWaitTime.cancel();\r\n"
				+ "		TimerTask task = new TimerTask() {\r\n"
				+ "			@Override\r\n"
				+ "			public void run() {\r\n"
				+ "				try {\r\n"
				+ "					end();\r\n"
				+ "				} catch (Exception e) {\r\n"
				+ "					e.printStackTrace();\r\n"
				+ "				}\r\n"
				+ "			}\r\n"
				+ "		};\r\n"
				+ "		timerWaitTime = new Timer();\r\n"
				+ "		timerWaitTime.schedule(task, milisec);\r\n"
				+ "	}\r\n"
				+ "\r\n"
				+ "	private void end() throws Exception {\r\n"
				+ "		client.disconnect();\r\n"
				+ "		client.close();\r\n"
				+ "		if (timerWaitTime != null)\r\n"
				+ "			timerWaitTime.cancel();\r\n"
				+ "		if (timerTimeRep != null)\r\n"
				+ "			timerTimeRep.cancel();\r\n"
				+ "		if (finalexec) {\r\n"
				+ "			end = true;\r\n"
				+ "			doWork();\r\n"
				+ "		}			\r\n"
				+ "		System.exit(0);\r\n"
				+ "	}\r\n"
				+ "\r\n"
				+ "	private void configParam(String[] argv) {\r\n"
				+ "		Option hostarg = Option.builder(\"ip\").longOpt(\"host\").argName(\"hostIP\").hasArg()\r\n"
				+ "				.desc(\"Host IP address (RabbitMQ server)\").build();\r\n"
				+ "\r\n"
				+ "		Option topicarg = Option.builder(\"t\").longOpt(\"topic\").argName(\"topicname\").hasArg().desc(\"Name of the topic\")\r\n"
				+ "				.build();\r\n"
				+ "\r\n"
				+ "		Option waitarg = Option.builder(\"w\").longOpt(\"wait\").argName(\"waittime\").hasArg()\r\n"
				+ "				.desc(\"Time in minutes that consumer is going to wait for a new message (Default: Undefined)\").build();\r\n"
				+ "\r\n"
				+ "		Option reparg = Option.builder(\"tr\").longOpt(\"timerep\").argName(\"interval\").hasArg()\r\n"
				+ "				.desc(\"Interval of algorithm execution in minutes (Default: Deactivated)\").build();\r\n"
				+ "\r\n"
				+ "		Option messagesarg = Option.builder(\"max\").longOpt(\"maxmessages\").argName(\"nummessages\").hasArg()\r\n"
				+ "				.desc(\"Maximum of waited messages (Default: Undefined)\").build();\r\n"
				+ "\r\n"
				+ "		Option messagereparg = Option.builder(\"mr\").longOpt(\"messagerep\").argName(\"nummessages\").hasArg()\r\n"
				+ "				.desc(\"Repeat the algorithm execution after certain number of messages (Default: Deactivated)\").build();\r\n"
				+ "\r\n"
				+ "		Option portarg = Option.builder(\"p\").longOpt(\"port\").argName(\"portnumber\").hasArg()\r\n"
				+ "				.desc(\"Listening port of the server\").build();\r\n"
				+ "\r\n"
				+ "		Option userarg = Option.builder(\"u\").longOpt(\"user\").argName(\"username\").hasArg()\r\n"
				+ "				.desc(\"Username in autenticated connections\").build();\r\n"
				+ "\r\n"
				+ "		Option passarg = Option.builder(\"pass\").longOpt(\"password\").argName(\"password\").hasArg()\r\n"
				+ "				.desc(\"Password in authenticated connections\").build();\r\n"
				+ "\r\n"
				+ "		Options options = new Options();\r\n"
				+ "\r\n"
				+ "		options.addOption(\"h\", \"help\", false, \"Print the help message\");\r\n"
				+ "		options.addOption(hostarg);\r\n"
				+ "		options.addOption(topicarg);\r\n"
				+ "		options.addOption(waitarg);\r\n"
				+ "		options.addOption(messagesarg);\r\n"
				+ "		options.addOption(reparg);\r\n"
				+ "		options.addOption(messagereparg);\r\n"
				+ "		options.addOption(portarg);\r\n"
				+ "		options.addOption(userarg);\r\n"
				+ "		options.addOption(passarg);\r\n"
				+ "		options.addOption(\"pers\", \"persistent\", false,\r\n"
				+ "				\"One algorithm execution during all the consumer life. Will be updated with new data\");\r\n"
				+ "		options.addOption(\"del\", \"delused\", false, \"Delete used messages (Default: Deactivated)\");\r\n"
				+ "		options.addOption(\"fe\", \"finalexec\", false,\r\n"
				+ "				\"Enable one last execution after connection is closed (Default: Deactivated). \"\r\n"
				+ "						+ \"This flag is ignored when there is no repetition\");\r\n"
				+ "\r\n"
				+ "		try {\r\n"
				+ "			CommandLineParser parser = new DefaultParser();\r\n"
				+ "			CommandLine cmd = parser.parse(options, argv);\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"help\")) {\r\n"
				+ "				HelpFormatter formatter = new HelpFormatter();\r\n"
				+ "				formatter.printHelp(\"Consumer. Required fields: Host IP, Topic name\", options);\r\n"
				+ "				System.exit(0);\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			topic = cmd.getOptionValue(\"topic\");\r\n"
				+ "\r\n"
				+ "			if (cmd.getOptionValue(\"host\") == null) {\r\n"
				+ "				throw new org.apache.commons.cli.ParseException(\"IP address is required\");\r\n"
				+ "			} else if (topic == null) {\r\n"
				+ "				throw new org.apache.commons.cli.ParseException(\"Topic name is required\");\r\n"
				+ "			} else if (cmd.hasOption(\"delused\") && !cmd.hasOption(\"messagerep\") && !cmd.hasOption(\"timerep\")) {\r\n"
				+ "				throw new org.apache.commons.cli.ParseException(\r\n"
				+ "						\"--delused can only be activated when there is repetition\");\r\n"
				+ "			} else if (cmd.hasOption(\"wait\") && cmd.hasOption(\"timerep\")) {\r\n"
				+ "				if (Double.parseDouble(cmd.getOptionValue(\"timerep\")) >= Double\r\n"
				+ "						.parseDouble(cmd.getOptionValue(\"wait\"))) {\r\n"
				+ "					throw new org.apache.commons.cli.ParseException(\r\n"
				+ "							\"Wait time (--wait) has to be bigger than repetition time (--timerep)\");\r\n"
				+ "				}\r\n"
				+ "			} else if (cmd.hasOption(\"maxmessages\") && cmd.hasOption(\"messagerep\")) {\r\n"
				+ "				if (Integer.parseInt(cmd.getOptionValue(\"messagerep\")) >= Integer\r\n"
				+ "						.parseInt(cmd.getOptionValue(\"maxmessages\"))) {\r\n"
				+ "					throw new org.apache.commons.cli.ParseException(\r\n"
				+ "							\"Maximum number of messages (--maxmessages) has to be bigger than repetition for message number (--messagerep)\");\r\n"
				+ "				}\r\n"
				+ "			} else if (cmd.hasOption(\"messagerep\") && cmd.hasOption(\"timerep\")) {\r\n"
				+ "				throw new org.apache.commons.cli.ParseException(\r\n"
				+ "						\"It is not possible to select two types of repetition simultaneously\");\r\n"
				+ "			} else if (!cmd.hasOption(\"messagerep\") && !cmd.hasOption(\"timerep\") && !cmd.hasOption(\"wait\")\r\n"
				+ "					&& !cmd.hasOption(\"maxmessages\") && !cmd.hasOption(\"persistent\")) {\r\n"
				+ "				throw new org.apache.commons.cli.ParseException(\"Choose an execution option\");\r\n"
				+ "			} else if (cmd.hasOption(\"maxmessages\") && cmd.hasOption(\"wait\")) {\r\n"
				+ "				throw new org.apache.commons.cli.ParseException(\r\n"
				+ "						\"It is not possible to choose two type of halts simultaneously\");\r\n"
				+ "			} else if (cmd.hasOption(\"persistent\") && (cmd.hasOption(\"messagerep\") || cmd.hasOption(\"timerep\") || cmd.hasOption(\"delused\")\r\n"
				+ "					|| cmd.hasOption(\"finalexec\"))) {\r\n"
				+ "				throw new org.apache.commons.cli.ParseException(\r\n"
				+ "						\"Persistent mode does nott support algorithm repetition conditions, final execution nor delused option\");\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			brokerUrl = \"tcp://\" + cmd.getOptionValue(\"host\");\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"wait\")) {\r\n"
				+ "				if (Double.parseDouble(cmd.getOptionValue(\"wait\")) <= 0)\r\n"
				+ "					throw new org.apache.commons.cli.ParseException(\"--wait has to be > 0\");\r\n"
				+ "				milisec = (long) (Double.parseDouble(cmd.getOptionValue(\"wait\")) * 60000);\r\n"
				+ "			} else {\r\n"
				+ "				milisec = 0;\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"maxmessages\")) {\r\n"
				+ "				if (Integer.parseInt(cmd.getOptionValue(\"maxmessages\")) <= 0)\r\n"
				+ "					throw new org.apache.commons.cli.ParseException(\"--maxmessages has to be > 0\");\r\n"
				+ "				maxMessages = Integer.parseInt(cmd.getOptionValue(\"maxmessages\"));\r\n"
				+ "				maxMessagescont = 0;\r\n"
				+ "			} else {\r\n"
				+ "				maxMessages = 0;\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"messagerep\")) {\r\n"
				+ "				if (Integer.parseInt(cmd.getOptionValue(\"messagerep\")) <= 0)\r\n"
				+ "					throw new org.apache.commons.cli.ParseException(\"--messagerep has to be > 0\");\r\n"
				+ "				numMessages = Integer.parseInt(cmd.getOptionValue(\"messagerep\"));\r\n"
				+ "				numMessagescont = 0;\r\n"
				+ "			} else {\r\n"
				+ "				numMessages = 0;\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"timerep\")) {\r\n"
				+ "				if (Double.parseDouble(cmd.getOptionValue(\"wait\")) <= 0)\r\n"
				+ "					throw new org.apache.commons.cli.ParseException(\"--timerep has to be > 0\");\r\n"
				+ "				milisecRep = (long) (Double.parseDouble(cmd.getOptionValue(\"timerep\")) * 60000);\r\n"
				+ "			} else {\r\n"
				+ "				milisecRep = 0;\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"delused\")) {\r\n"
				+ "				delused = true;\r\n"
				+ "			} else {\r\n"
				+ "				delused = false;\r\n"
				+ "			}\r\n"
				+ "			\r\n"
				+ "			if (cmd.hasOption(\"persistent\")) {\r\n"
				+ "				persistent = true;\r\n"
				+ "			} else {\r\n"
				+ "				persistent = false;\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"finalexec\") || !(cmd.hasOption(\"timerep\") || cmd.hasOption(\"messagerep\"))) {\r\n"
				+ "				finalexec = true;\r\n"
				+ "			} else {\r\n"
				+ "				finalexec = false;\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"port\")) {\r\n"
				+ "				if (Integer.parseInt(cmd.getOptionValue(\"port\")) <= 0)\r\n"
				+ "					throw new org.apache.commons.cli.ParseException(\"--port has to be > 0\");\r\n"
				+ "				brokerUrl = brokerUrl += \":\" + cmd.getOptionValue(\"port\");\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"user\")) {\r\n"
				+ "				username = cmd.getOptionValue(\"user\");\r\n"
				+ "			} else {\r\n"
				+ "				username = \"\";\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"password\")) {\r\n"
				+ "				password = cmd.getOptionValue(\"password\");\r\n"
				+ "			} else {\r\n"
				+ "				password = \"\";\r\n"
				+ "			}\r\n"
				+ "		} catch (ParseException | NumberFormatException exp) {\r\n"
				+ "			System.err.println(\"Error with introduced parameters.  Reason: \" + exp.getMessage());\r\n"
				+ "			HelpFormatter formatter = new HelpFormatter();\r\n"
				+ "			formatter.printHelp(\"Consumer MQTT. Required fields: Host IP, Topic name\", options);\r\n"
				+ "			System.exit(0);\r\n"
				+ "		}\r\n"
				+ "	}\r\n"
				+ "}";
		
		return mqtt;
	}
	
	public static String getAMQP(String className, String schemaName) {
		String amqp = "import com.rabbitmq.client.Channel;\r\n"
				+ "import com.rabbitmq.client.Connection;\r\n"
				+ "import com.rabbitmq.client.ConnectionFactory;\r\n"
				+ "import com.rabbitmq.client.DeliverCallback;\r\n"
				+ "import java.util.ArrayList;\r\n"
				+ "import java.util.Timer;\r\n"
				+ "import java.util.TimerTask;\r\n"
				+ "import java.util.concurrent.LinkedBlockingQueue;\r\n"
				+ "import com.fasterxml.jackson.core.JsonProcessingException;\r\n"
				+ "import com.fasterxml.jackson.core.type.TypeReference;\r\n"
				+ "import com.fasterxml.jackson.databind.DeserializationFeature;\r\n"
				+ "import com.fasterxml.jackson.databind.ObjectMapper;\r\n"
				+ "import com.fasterxml.jackson.databind.SerializationFeature;\r\n"
				+ "import org.apache.commons.cli.*;\r\n"
				+ "\r\n"
				+ "public class "+className+" {\r\n"
				+ "	private Timer timerWaitTime;\r\n"
				+ "	private long milisec;\r\n"
				+ "\r\n"
				+ "	private Timer timerTimeRep;\r\n"
				+ "	private long milisecRep;\r\n"
				+ "\r\n"
				+ "	private int numMessages;\r\n"
				+ "	private int numMessagescont;\r\n"
				+ "\r\n"
				+ "	private int maxMessages;\r\n"
				+ "	private int maxMessagescont;\r\n"
				+ "\r\n"
				+ "	private boolean delused;\r\n"
				+ "	private boolean finalexec;\r\n"
				+ "\r\n"
				+ "	private String host;\r\n"
				+ "	private String queueName;\r\n"
				+ " 	private int port;\r\n"
				+ "	private String username;\r\n"
				+ "	private String password;\r\n"
				+ "\r\n"
				+ "	private String consTag;\r\n"
				+ "	private Connection connectionaux;\r\n"
				+ "	private Channel channelaux;\r\n"
				+ "\r\n"
				+ "	private boolean end;\r\n"
				+ "\r\n"
				+ "	private boolean persistent;\r\n"
				+ "	private Timer timerPersistent;\r\n"
				+ "	\r\n"
				+ "	private Thread t;\r\n"
				+ "	\r\n"
				+ "	private LinkedBlockingQueue<"+schemaName+"> lbq;\r\n"
				+ "\r\n"
				+ "	public static void main(String[] args) {\r\n"
				+ "		"+className+ " consumer = new "+className+ "(args);\r\n"
				+ "	}\r\n"
				+ "	\r\n"
				+ "	public "+className+"(String[] argv) {\r\n"
				+ "		configParam(argv);\r\n"
				+ "		lbq = new LinkedBlockingQueue<"+schemaName+">();\r\n"
				+ "\r\n"
				+ "		try {\r\n"
				+ "			if(persistent) {\r\n"
				+ "				doWork();\r\n"
				+ "				timerPersistent = new Timer();\r\n"
				+ "				TimerTask task_pers = new TimerTask() {\r\n"
				+ "					@Override\r\n"
				+ "					public void run() {\r\n"
				+ "						try {\r\n"
				+ "							if(!t.isAlive()) {\r\n"
				+ "								end();\r\n"
				+ "							}\r\n"
				+ "						} catch (Exception e) {\r\n"
				+ "							e.printStackTrace();\r\n"
				+ "						}\r\n"
				+ "					}\r\n"
				+ "				};\r\n"
				+ "				timerPersistent.scheduleAtFixedRate(task_pers, 10, 10);\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			ConnectionFactory factory = new ConnectionFactory();\r\n"
				+ "			factory.setHost(host);\r\n"
				+ "			if (port != -1) factory.setPort(port);\r\n"
				+ "			if (!username.equals(\"\")) factory.setUsername(username);\r\n"
				+ "			if (!password.equals(\"\")) factory.setPassword(password);\r\n"
				+ "\r\n"
				+ "			Connection connection = factory.newConnection();\r\n"
				+ "			connectionaux = connection;\r\n"
				+ "			Channel channel = connection.createChannel();\r\n"
				+ "			channelaux = channel;\r\n"
				+ "			boolean durable = false;\r\n"
				+ "			channel.queueDeclare(queueName, durable, false, false, null);\r\n"
				+ "			channel.basicQos(2);\r\n"
				+ "\r\n"
				+ "			DeliverCallback deliverCallback = (consumerTag, delivery) -> {\r\n"
				+ "			if (timerWaitTime != null)\r\n"
				+ "					reset();\r\n"
				+ "				try {\r\n"
				+ "					processMessage(new String(delivery.getBody(), \"UTF-8\"));\r\n"
				+ "					if (maxMessages != 0)\r\n"
				+ "						maxMessagescont++;\r\n"
				+ "					if (maxMessagescont != 0 && maxMessages == maxMessagescont) {\r\n"
				+ "						end();\r\n"
				+ "					}\r\n"
				+ "					if (numMessages != 0)\r\n"
				+ "						numMessagescont++;\r\n"
				+ "					if (numMessages != 0 && numMessages == numMessagescont) {\r\n"
				+ "						doWork();\r\n"
				+ "						numMessagescont = 0;\r\n"
				+ "					}\r\n"
				+ "				} catch (Exception e) {\r\n"
				+ "					e.printStackTrace();\r\n"
				+ "				}\r\n"
				+ "			};\r\n"
				+ "\r\n"
				+ "			boolean autoAck = true;\r\n"
				+ "			consTag = channel.basicConsume(queueName, autoAck, deliverCallback, consumerTag -> {});\r\n"
				+ "			if (milisec > 0) {\r\n"
				+ "				timerWaitTime = new Timer();\r\n"
				+ "				TimerTask task = new TimerTask() {\r\n"
				+ "					@Override\r\n"
				+ "					public void run() {\r\n"
				+ "						try {\r\n"
				+ "							end();\r\n"
				+ "						} catch (Exception e) {\r\n"
				+ "							e.printStackTrace();\r\n"
				+ "						}\r\n"
				+ "					}\r\n"
				+ "				};\r\n"
				+ "				timerWaitTime.schedule(task, milisec);\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (milisecRep > 0) {\r\n"
				+ "				timerTimeRep = new Timer();\r\n"
				+ "				TimerTask task_rep = new TimerTask() {\r\n"
				+ "					@Override\r\n"
				+ "					public void run() {\r\n"
				+ "						try {\r\n"
				+ "							doWork();\r\n"
				+ "						} catch (Exception e) {\r\n"
				+ "							e.printStackTrace();\r\n"
				+ "						}\r\n"
				+ "					}\r\n"
				+ "				};\r\n"
				+ "				timerTimeRep.scheduleAtFixedRate(task_rep, milisecRep, milisecRep);\r\n"
				+ "			}\r\n"
				+ "		}catch(Exception e) {\r\n"
				+ "			e.printStackTrace();\r\n"
				+ "			System.exit(0);\r\n"
				+ "		}\r\n"
				+ "	}\r\n"
				+ "\r\n"
				+ "	private void processMessage(String message) {\r\n"
				+ "		ObjectMapper mapper = new ObjectMapper().\r\n"
				+ "				enable(SerializationFeature.INDENT_OUTPUT).\r\n"
				+ "				enable(DeserializationFeature.ACCEPT_SINGLE_VALUE_AS_ARRAY);\r\n"
				+ "		try {\r\n"
				+ "			ArrayList<"+schemaName+"> dataToProcess = mapper.readValue(message, new TypeReference<ArrayList<"+schemaName+">>() {\r\n"
				+ "			});\r\n"
				+ "			lbq.addAll(dataToProcess);\r\n"
				+ "		} catch (JsonProcessingException e) {\r\n"
				+ "			System.out.println(\"Warning: Malformed message\");\r\n"
				+ "			System.out.println(message);\r\n"
				+ "		}\r\n"
				+ "	}\r\n"
				+ "\r\n"
				+ "	private void doWork() {\r\n"
				+ "		if(t == null) {\r\n"
				+ "			if(!persistent) {\r\n"
				+ "				LinkedBlockingQueue<"+schemaName+"> clone = new LinkedBlockingQueue<>();\r\n"
				+ "				clone.addAll(lbq);\r\n"
				+ "				Runnable algorithm = new Algorithm(clone);\r\n"
				+ "				t = new Thread(algorithm);\r\n"
				+ "				t.start();\r\n"
				+ "			} else {\r\n"
				+ "				Runnable algorithm = new Algorithm(lbq);\r\n"
				+ "				t = new Thread(algorithm);\r\n"
				+ "				t.start();\r\n"
				+ "			}\r\n"
				+ "		} else if (!persistent) {\r\n"
				+ "			if(!t.isAlive()) {\r\n"
				+ "				LinkedBlockingQueue<"+schemaName+"> clone = new LinkedBlockingQueue<>();\r\n"
				+ "				clone.addAll(lbq);\r\n"
				+ "				Runnable algorithm = new Algorithm(clone);\r\n"
				+ "				t = new Thread(algorithm);\r\n"
				+ "				t.start();\r\n"
				+ "			}\r\n"
				+ "		}\r\n"
				+ "		\r\n"
				+ "		if (delused) {\r\n"
				+ "			lbq.clear();\r\n"
				+ "		}\r\n"
				+ "		\r\n"
				+ "		if (end) {\r\n"
				+ "			try {\r\n"
				+ "				t.join();\r\n"
				+ "			} catch (InterruptedException e) {\r\n"
				+ "				e.printStackTrace();\r\n"
				+ "			}\r\n"
				+ "		}\r\n"
				+ "	}\r\n"
				+ "\r\n"
				+ "	private void reset() {\r\n"
				+ "		timerWaitTime.cancel();\r\n"
				+ "		TimerTask task = new TimerTask() {\r\n"
				+ "			@Override\r\n"
				+ "			public void run() {\r\n"
				+ "				try {\r\n"
				+ "					end();\r\n"
				+ "				} catch (Exception e) {\r\n"
				+ "					e.printStackTrace();\r\n"
				+ "				}\r\n"
				+ "			}\r\n"
				+ "		};\r\n"
				+ "		timerWaitTime = new Timer();\r\n"
				+ "		timerWaitTime.schedule(task, milisec);\r\n"
				+ "	}\r\n"
				+ "	\r\n"
				+ "	private void end() throws Exception {\r\n"
				+ "		channelaux.basicCancel(consTag);\r\n"
				+ "		channelaux.queueDelete(queueName);\r\n"
				+ "		channelaux.close();\r\n"
				+ "		connectionaux.close();\r\n"
				+ "		if (timerWaitTime != null)\r\n"
				+ "			timerWaitTime.cancel();\r\n"
				+ "		if (timerTimeRep != null)\r\n"
				+ "			timerTimeRep.cancel();\r\n"
				+ "		if (finalexec) {\r\n"
				+ "			end = true;\r\n"
				+ "			doWork();\r\n"
				+ "		}\r\n"
				+ "		System.exit(0);\r\n"
				+ "	}"
				+ "	\r\n"
				+ "	private void configParam(String[] argv) {\r\n"
				+ "		Option hostarg = Option.builder(\"ip\").longOpt(\"hostip\").argName(\"hostIP\").hasArg()\r\n"
				+ "				.desc(\"Host IP address (RabbitMQ server)\").build();\r\n"
				+ "\r\n"
				+ "		Option queuearg = Option.builder(\"q\").longOpt(\"queue\").argName(\"queuename\").hasArg().desc(\"Name of the queue\")\r\n"
				+ "				.build();\r\n"
				+ "\r\n"
				+ "		Option waitarg = Option.builder(\"w\").longOpt(\"wait\").argName(\"waittime\").hasArg()\r\n"
				+ "				.desc(\"Time in minutes that consumer is going to wait for a new message (Default: Undefined)\").build();\r\n"
				+ "\r\n"
				+ "		Option reparg = Option.builder(\"tr\").longOpt(\"timerep\").argName(\"interval\").hasArg()\r\n"
				+ "				.desc(\"Interval of algorithm execution in minutes (Default: Deactivated)\").build();\r\n"
				+ "\r\n"
				+ "		Option messagesarg = Option.builder(\"max\").longOpt(\"maxmessages\").argName(\"nummessages\").hasArg()\r\n"
				+ "				.desc(\"Maximum of waited messages (Default: Undefined)\").build();\r\n"
				+ "\r\n"
				+ "		Option messagereparg = Option.builder(\"mr\").longOpt(\"messagerep\").argName(\"nummessages\").hasArg()\r\n"
				+ "				.desc(\"Repeat the algorithm execution after certain number of messages (Default: Deactivated)\").build();\r\n"
				+ "\r\n"
				+ "		Option portarg = Option.builder(\"p\").longOpt(\"port\").argName(\"portnumber\").hasArg()\r\n"
				+ "				.desc(\"Listening port of the server\").build();\r\n"
				+ "\r\n"
				+ "		Option userarg = Option.builder(\"u\").longOpt(\"user\").argName(\"username\").hasArg()\r\n"
				+ "				.desc(\"Username in autenticated connections\").build();\r\n"
				+ "\r\n"
				+ "		Option passarg = Option.builder(\"pass\").longOpt(\"password\").argName(\"password\").hasArg()\r\n"
				+ "				.desc(\"Password in authenticated connections\").build();\r\n"
				+ "\r\n"
				+ "		Options options = new Options();\r\n"
				+ "\r\n"
				+ "		options.addOption(\"h\", \"help\", false, \"Print the help message\");\r\n"
				+ "		options.addOption(hostarg);\r\n"
				+ "		options.addOption(queuearg);\r\n"
				+ "		options.addOption(waitarg);\r\n"
				+ "		options.addOption(messagesarg);\r\n"
				+ "		options.addOption(reparg);\r\n"
				+ "		options.addOption(messagereparg);\r\n"
				+ "		options.addOption(portarg);\r\n"
				+ "		options.addOption(userarg);\r\n"
				+ "		options.addOption(passarg);\r\n"
				+ "		options.addOption(\"pers\", \"persistent\", false,\r\n"
				+ "				\"One algorithm execution during all the consumer life. Will be updated with new data\");\r\n"
				+ "		options.addOption(\"del\", \"delused\", false, \"Delete used messages (Default: Deactivated)\");\r\n"
				+ "		options.addOption(\"fe\", \"finalexec\", false,\r\n"
				+ "				\"Enable one last execution after connection is closed (Default: Deactivated). \"\r\n"
				+ "						+ \"This flag is ignored when there is no repetition\");\r\n"
				+ "\r\n"
				+ "		try {\r\n"
				+ "			CommandLineParser parser = new DefaultParser();\r\n"
				+ "			CommandLine cmd = parser.parse(options, argv);\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"help\")) {\r\n"
				+ "				HelpFormatter formatter = new HelpFormatter();\r\n"
				+ "				formatter.printHelp(\"Consumer. Required fields: Host IP, Topic name\", options);\r\n"
				+ "				System.exit(0);\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			host = cmd.getOptionValue(\"hostip\");\r\n"
				+ "			queueName = cmd.getOptionValue(\"queue\");\r\n"
				+ "			if (host == null) {\r\n"
				+ "				throw new org.apache.commons.cli.ParseException(\"IP address is required\");\r\n"
				+ "			} else if (queueName == null) {\r\n"
				+ "				throw new org.apache.commons.cli.ParseException(\"Queue name is required\");\r\n"
				+ "			} else if (cmd.hasOption(\"delused\") && !cmd.hasOption(\"messagerep\") && !cmd.hasOption(\"timerep\")) {\r\n"
				+ "				throw new org.apache.commons.cli.ParseException(\r\n"
				+ "						\"--delused can only be activated when there is repetition\");\r\n"
				+ "			} else if (cmd.hasOption(\"wait\") && cmd.hasOption(\"timerep\")) {\r\n"
				+ "				if (Double.parseDouble(cmd.getOptionValue(\"timerep\")) > Double\r\n"
				+ "						.parseDouble(cmd.getOptionValue(\"wait\"))) {\r\n"
				+ "					throw new org.apache.commons.cli.ParseException(\r\n"
				+ "							\"Wait time (--wait) has to be bigger than repetition time (--timerep)\");\r\n"
				+ "				}\r\n"
				+ "			} else if (cmd.hasOption(\"maxmessages\") && cmd.hasOption(\"messagerep\")) {\r\n"
				+ "				if (Integer.parseInt(cmd.getOptionValue(\"messagerep\")) > Integer\r\n"
				+ "						.parseInt(cmd.getOptionValue(\"maxmessages\"))) {\r\n"
				+ "					throw new org.apache.commons.cli.ParseException(\r\n"
				+ "							\"Maximum number of messages (--maxmessages) has to be bigger than repetition for message number (--messagerep)\");\r\n"
				+ "				}\r\n"
				+ "			} else if (cmd.hasOption(\"messagerep\") && cmd.hasOption(\"timerep\")) {\r\n"
				+ "				throw new org.apache.commons.cli.ParseException(\r\n"
				+ "						\"It is not possible to select two types of repetition simultaneously\");\r\n"
				+ "			} else if (!cmd.hasOption(\"messagerep\") && !cmd.hasOption(\"timerep\") && !cmd.hasOption(\"wait\")\r\n"
				+ "					&& !cmd.hasOption(\"maxmessages\") && !cmd.hasOption(\"persistent\")) {\r\n"
				+ "				throw new org.apache.commons.cli.ParseException(\"Choose an execution option\");\r\n"
				+ "			} else if (cmd.hasOption(\"maxmessages\") && cmd.hasOption(\"wait\")) {\r\n"
				+ "				throw new org.apache.commons.cli.ParseException(\r\n"
				+ "						\"It is not possible to choose two type of halts simultaneously\");\r\n"
				+ "			} else if (cmd.hasOption(\"persistent\") && (cmd.hasOption(\"messagerep\") || cmd.hasOption(\"timerep\") || cmd.hasOption(\"delused\")\r\n"
				+ "					|| cmd.hasOption(\"finalexec\"))) {\r\n"
				+ "				throw new org.apache.commons.cli.ParseException(\r\n"
				+ "						\"Persistent mode does not support algorithm repetition conditions, final execution nor delused option\");\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"wait\")) {\r\n"
				+ "				if (Double.parseDouble(cmd.getOptionValue(\"wait\")) <= 0)\r\n"
				+ "					throw new org.apache.commons.cli.ParseException(\"--wait has to be > 0\");\r\n"
				+ "				milisec = (long) (Double.parseDouble(cmd.getOptionValue(\"wait\")) * 60000);\r\n"
				+ "			} else {\r\n"
				+ "				milisec = 0;\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"maxmessages\")) {\r\n"
				+ "				if (Integer.parseInt(cmd.getOptionValue(\"maxmessages\")) <= 0)\r\n"
				+ "					throw new org.apache.commons.cli.ParseException(\"--maxmessages has to be > 0\");\r\n"
				+ "				maxMessages = Integer.parseInt(cmd.getOptionValue(\"maxmessages\"));\r\n"
				+ "				maxMessagescont = 0;\r\n"
				+ "			} else {\r\n"
				+ "				maxMessages = 0;\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"messagerep\")) {\r\n"
				+ "				if (Integer.parseInt(cmd.getOptionValue(\"messagerep\")) <= 0)\r\n"
				+ "					throw new org.apache.commons.cli.ParseException(\"--messagerep has to be > 0\");\r\n"
				+ "				numMessages = Integer.parseInt(cmd.getOptionValue(\"messagerep\"));\r\n"
				+ "				numMessagescont = 0;\r\n"
				+ "			} else {\r\n"
				+ "				numMessages = 0;\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"timerep\")) {\r\n"
				+ "				if (Double.parseDouble(cmd.getOptionValue(\"wait\")) <= 0)\r\n"
				+ "					throw new org.apache.commons.cli.ParseException(\"--timerep has to be > 0\");\r\n"
				+ "				milisecRep = (long) (Double.parseDouble(cmd.getOptionValue(\"timerep\")) * 60000);\r\n"
				+ "			} else {\r\n"
				+ "				milisecRep = 0;\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"delused\")) {\r\n"
				+ "				delused = true;\r\n"
				+ "			} else {\r\n"
				+ "				delused = false;\r\n"
				+ "			}\r\n"
				+ "			\r\n"
				+ "			if (cmd.hasOption(\"persistent\")) {\r\n"
				+ "				persistent = true;\r\n"
				+ "			} else {\r\n"
				+ "				persistent = false;\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"finalexec\") || !(cmd.hasOption(\"timerep\") || cmd.hasOption(\"messagerep\"))) {\r\n"
				+ "				finalexec = true;\r\n"
				+ "			} else {\r\n"
				+ "				finalexec = false;\r\n"
				+ "			}\r\n"
				+ "			if (cmd.hasOption(\"port\")) {\r\n"
				+ "				if (Integer.parseInt(cmd.getOptionValue(\"port\")) <= 0)\r\n"
				+ "					throw new org.apache.commons.cli.ParseException(\"--port has to be > 0\");\r\n"
				+ "				port = Integer.parseInt(cmd.getOptionValue(\"port\"));\r\n"
				+ "			}else {\r\n"
				+ "				port = -1;\r\n"
				+ "			}\r\n"
				+ "\r\n"
				+ "			if (cmd.hasOption(\"user\")) {\r\n"
				+ "				username = cmd.getOptionValue(\"user\");\r\n"
				+ "			}else {\r\n"
				+ "				username = \"\";\r\n"
				+ "			}\r\n"
				+ "			\r\n"
				+ "			if (cmd.hasOption(\"password\")) {\r\n"
				+ "				password = cmd.getOptionValue(\"password\");\r\n"
				+ "			}else {\r\n"
				+ "				password = \"\";\r\n"
				+ "			}\r\n"
				+ "		} catch (ParseException | NumberFormatException exp) {\r\n"
				+ "			System.err.println(\"Error with introduced parameters.  Reason: \" + exp.getMessage());\r\n"
				+ "			HelpFormatter formatter = new HelpFormatter();\r\n"
				+ "			formatter.printHelp(\"Consumer AMQP. Required fields: Host IP, Queue name\", options);\r\n"
				+ "			System.exit(0);\r\n"
				+ "		}\r\n"
				+ "	}\r\n"
				+ "}";
		return amqp;
	}
	
}
